function Opl00100LoteDeEnvioDePedidosDoOL_Controller(ScreenService, templateManager, ZhFilterPreferences, General, restEngine, ZhReports, MessageService) {
    
    this.openFilter = function(widget) {
    	ScreenService.showLoader();
        this.setFieldsGerais(widget);
        var rowsToSet = {};
		rowsToSet.defaultFilter = widget.dataSourceFilter;
		rowsToSet.TCDLOTENVITOL = 'T';
		widget.getField("P_CDLOTENVITOL").filterProperties.readOnly = true;
		widget.getField("P_CDLOTENVITOL").filterProperties.readOnlyOnEdit = true;
		delete widget.getField("P_CDLOTENVITOL").filterProperties.validations.required;
		delete widget.getField("P_CDLOTENVITOL").validations.required;
		
		ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(opened => {
			ScreenService.hideLoader();
		}).catch(error => {
			console.log(error);
			ScreenService.hideLoader();
		});
    };

	this.setFieldsGerais = function(widget) {
		templateManager.container.fieldsGerais = widget.fields.map(function(field) { return field.name; });
	};
	
	this.changeFieldLote = function(args) {
		var widget = args.owner.field.widget;
		ScreenService.showLoader();
		if(args.row.TCDLOTENVITOL == 'T') {
			if(widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("P_CDLOTENVITOL").readOnly = true;
					widget.getField("P_CDLOTENVITOL").readOnlyOnEdit = true;
					delete widget.getField("P_CDLOTENVITOL").validations.required;
					widget.currentRow.P_CDLOTENVITOL = "";
					widget.currentRow.NMLOTENVITOL = "";
					widget.getField("P_CDLOTENVITOL").clearValue();
					widget.getField("P_CDLOTENVITOL").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		} else if(args.row.TCDLOTENVITOL == 'L') {
			if(widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("P_CDLOTENVITOL").readOnly = false;
					widget.getField("P_CDLOTENVITOL").readOnlyOnEdit = false;
					widget.getField("P_CDLOTENVITOL").validations.required = true;
					widget.getField("P_CDLOTENVITOL").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		}
	};
	
	this.saveEdit = function(widget) {
		if(widget.isValid()) {
			widget.saveRow().then(function(response) {
				widget.dataSource.data.pop();
				
				ScreenService.closeSwipe();
				
				widget.reload();
				
				MessageService.showMessageByCode("OPERACAO_SUCESSO");
			}, function(error) {
				MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
			});
		}
	};
	
	this.newLote = function(widget) {
    	widget.getField("CDLOTENVITOL").readOnly = true;
        widget.getField("CDLOTENVITOL").validations.required = true;
        widget.getField("CDLOTENVITOL").minlength = 10;
        widget.getField("CDLOTENVITOL").maxlength = 10;
        
        General.callRestEngine("opl_solicitacao#/getNewLoteCode", "Row", {}).then(function(response) {
        	var novoCodigo = response.dataset.opl00100_newCode[0];
        	
        	if(novoCodigo) {
        		var geraNovoCodigo = false;
        		
        		widget.newRow();
        		
        		widget.dataSource.data.forEach(function(row) {
        			if(row.CDLOTENVITOL == novoCodigo)
        				geraNovoCodigo = true;
        		});
        		
        		if(geraNovoCodigo) {
	        		novoCodigo = widget.dataSource.data[widget.dataSource.data.length - 2].CDLOTENVITOL;
	            	novoCodigo = parseInt(novoCodigo);
	        		novoCodigo++;
	        		novoCodigo = novoCodigo.toString();
	        		novoCodigo = novoCodigo.padStart(10, 0);
        		}
        		
        		widget.currentRow.CDLOTENVITOL = novoCodigo;
        		widget.getField("CDLOTENVITOL").setValue(novoCodigo);
        	} else {
        		widget.view();
				widget.enabled = true;
				widget.reload();
        		MessageService.showMessageByCode("UNKNOWN_ERROR");
        	}
        }).catch(function(error) {
        	widget.view();
			widget.enabled = true;
			widget.reload();
        	MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
        });
	};
	
	this.fillField = function(args) {
		var field = args.owner.field.widget.getField("CDLOTENVITOL");
		var value = field.value();
		var row = args.row;
		value = value.padStart(10, '0');
		field.setValue(value);
		field.value(value);
		row.CDLOTENVITOL = value;
		field.reload();
	};

    this.validateReport = function(widget, type) {
    	var REPORT_JSON = "./modules/consolidacao/assets/modules/solicitacao/assets/json/containers/opl00100_lote_de_envio_de_pedidos_do_OL.json";
    	
    	ScreenService.showLoader();
    	
        restEngine.requestMetaData(REPORT_JSON).then(function(reportMetaData) {
            ScreenService.hideLoader();
            
            ZhReports.openReport(reportMetaData.data, widget, null, null, type).then(function(success) {
            	
            }).catch(error1 => {
            	MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error1.data.error });
            });
        }).catch(error => {
        	MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
        });
    };
    
    this.cancelEditNew = function(args) {
    	const widget = args.owner.widget;
    	
    	General.backOrCancel(args).then(function(response) {
    		ScreenService.closeSwipe();
    		widget.reload();
    	});
    };
}

Configuration(function(ContextRegister) {
	ContextRegister.register('Opl00100LoteDeEnvioDePedidosDoOL_Controller', Opl00100LoteDeEnvioDePedidosDoOL_Controller);
});